import pygtk
pygtk.require('2.0')
import gtk

class JukeDialog:
   def __init__(self, parent, pmessage, smessage=None):
      self.parent = parent
      self.pmessage = pmessage
      self.smessage = smessage
      self.flags = None
      self.type = None
      self.buttons = None
      self.title = None

   def run(self):
      dialog = gtk.MessageDialog(self.parent, self.flags, self.type, self.buttons, self.pmessage)
      if self.smessage:
         dialog.format_secondary_text(self.smessage)
      if self.title:
         dialog.set_title(self.title)
      response = dialog.run()
      dialog.destroy()
      return response

class JukeInfoDialog(JukeDialog):
   def __init__(self, parent, pmessage, smessage=None):
      JukeDialog.__init__(self, parent, pmessage, smessage)
      self.flags = gtk.DIALOG_MODAL
      self.type = gtk.MESSAGE_INFO
      self.buttons = gtk.BUTTONS_OK
      self.title = 'JukeTV Information'

class JukeWarningDialog(JukeDialog):
   def __init__(self, parent, pmessage, smessage=None):
      JukeDialog.__init__(self, parent, pmessage, smessage)
      self.flags = gtk.DIALOG_MODAL
      self.type = gtk.MESSAGE_WARNING
      self.buttons = gtk.BUTTONS_CLOSE
      self.title = 'JukeTV Warning'

class JukeErrorDialog(JukeDialog):
   def __init__(self, parent, pmessage, smessage=None):
      JukeDialog.__init__(self, parent, pmessage, smessage)
      self.flags = gtk.DIALOG_MODAL
      self.type = gtk.MESSAGE_ERROR
      self.buttons = gtk.BUTTONS_CLOSE
      self.title = 'JukeTV Error'
