import dialogs
from xml_parsers import ClientParser
from xml_editors import ClientEditor
import connection_utilities

class EditConnectionHandler:
   def __init__(self, builder):
      self.builder = builder
      connection_utilities.initAnyConnView('editConnView', self.builder, self.onConnectionSelectionChanged)
      self.tree_selection = None

   def onEditConnItemClicked(self, editConnItem):
      parser = ClientParser()
      parser.load()
      conns = parser.getConnectionList()
      connection_utilities.populateAnyConnView(conns, 'editConnStore', self.builder)
      self.builder.get_object('connectionEditWindow').show()

   def onEditConnDoneButtonClicked(self, button):
      self.builder.get_object('connectionEditWindow').hide()

   def onEditConnDeleteButtonClicked(self, button):
      editConnStore, iter = self.treeSelection.get_selected()
      host = editConnStore.get(iter, 0)[0]
      port = editConnStore.get(iter, 1)[0]
      editor = ClientEditor()
      editor.load()
      editor.deleteOneSavedConnection(host, port)
      parser = ClientParser()
      parser.load()
      conns = parser.getConnectionList()
      connection_utilities.populateAnyConnView(conns, 'editConnStore', self.builder)

   def onEditConnAddButtonClicked(self, button):
      self.builder.get_object('addConnDialog').show()

   def onAddCancelButtonClicked(self, button):
      self.builder.get_object('addConnDialog').hide()

   def onAddSaveButtonClicked(self, button):
      host = self.builder.get_object('addHostEntry').get_text()
      port = self.builder.get_object('addPortSpinButton').get_text()
      editor = ClientEditor()
      editor.load()
      editor.addSavedConnection(host, port)
      self.builder.get_object('addConnDialog').hide()
      parser = ClientParser()
      parser.load()
      conns = parser.getConnectionList()
      connection_utilities.populateAnyConnView(conns, 'editConnStore', self.builder)


   #def populateEditView(self, conns):
   #   editStore = self.builder.get_object('editConnStore')
   #   editStore.clear()
   #   for conn in conns:
   #      editStore.append([conn[0], conn[1]])

   def onConnectionSelectionChanged(self, treeSelection, userdata):
      self.treeSelection = treeSelection
