import socket

BUFFER_SIZE = 4096 

class JSocket:
   
   def receiveAll(self):
      msg = ''
      while True:
         chunk = self.socket.recv(BUFFER_SIZE)
         if chunk == '':
            return msg
         msg = msg + chunk
   
   def sendAll(self, msg):
      totalsent = 0
      while totalsent < len(msg):
         sent = self.socket.send(msg[totalsent:])
         if sent == 0:
            raise RunTimeError, 'Outgoing socket disconnected.'
         totalsent = totalsent + sent

   def shutdown(self, sargs):
      self.socket.shutdown(sargs)

   def close(self):
      self.socket.close()

class ClientSocket(JSocket):
   def __init__(self, addr=None, port=None, sock=None):
      if addr != None and port != None and sock==None:
         self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
         self.socket.connect((socket.gethostbyname(addr), port))
      elif sock != None:
         self.socket = sock
      else:
         raise RunTimeError, 'Must either supply socket or addr and port.'

class ServerSocket(JSocket):
   def __init__(self, addr, port):
      self.serversocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
      self.serversocket.bind((socket.gethostbyname(addr), port))
      self.serversocket.listen(5)

   def accept(self):
      client, addr = self.serversocket.accept()
      return ClientSocket(sock=client), addr
