#!/usr/bin/env python
import socket
from xml_parsers import ServerParser
from server_message_parser import ServerMsgParser
from juke_socket import ServerSocket
from sys import exit

class NetListener:
   def __init__(self):
      self.settings = ServerParser()
      self.settings.load()
      self.msgParser = ServerMsgParser(self.settings)
      connected = False
      attempts = 1
      while not connected:
         if attempts > self.settings.getMaxAttempts():
            print 'Reached maximum number of attempts.'
            print 'Now exiting...'
            exit(1)
            break
         attempts += 1
         try:
            connected = True
            self.serversock = ServerSocket(self.settings.getAddress(), int(self.settings.getPort()))
         except:
            print 'Failed to get a network connection.'
            print 'Trying again...'
            connected = False

   def run(self):
      while True:
         # accept connections from the client
         client, addr = self.serversock.accept()
         msg = client.receiveAll()
         self.msgParser.load(msg)
         command = self.msgParser.getCommand()
         retval = command.execute()
         client.sendAll(retval)
         client.shutdown(socket.SHUT_RDWR)
         client.close()

      # TODO: exit loop cleanly on interrupt

if __name__ == '__main__':
   listener = NetListener()
   listener.run()
