def replaceStr(format, replacee, replacer):
   """ Replaces the first occurrence of replacee with replacer """
   index = format.find(replacee)
   return format[:index] + replacer + format[index+len(replacee):]

class PathConverter:
   def __init__(self, dirList):
      self.dirList = dirList

   def virtualToAbsolute(self, virtualPath):
      secondSlashIndex = virtualPath[1:].find('/') + 1
      if secondSlashIndex == 0:
         secondSlashIndex = len(virtualPath)
      rootDir = virtualPath[1:secondSlashIndex]
      absolutePath = ''
      for dir in self.dirList:
         if rootDir == dir[0]:
            absolutePath = replaceStr(virtualPath, dir[0], dir[1])
            break
      return absolutePath

   def absoluteToVirtual(self, absPath):
      secondSlashIndex = absPath[1:].find('/') + 1
      if secondSlashIndex == 0:
         secondSlashIndex = len(absPath)
      rootDir = absPath[1:secondSlashIndex]
      for dir in self.dirList:
         if rootDir == dir[0]:
            virtualPath = replaceStr(absPath, dir[1], dir[0])
            break
      return virtualPath

